part of '../../internals.dart';

class _EsESLanguageDetails extends QudsLanguageDetails {
  @override
  String get abbreviatedName => 'Es';

  @override
  String get countryCode => 'ES';

  @override
  String get langCode => 'es';

  @override
  TextDirection get textDirection => TextDirection.ltr;

  @override
  String get langName => 'Spanish';

  @override
  String get countryName => 'Spain';

  @override
  Map<String, String> get dictionary => {
        'Back': 'volver',
        'Save': 'grabar',
        'Current Language': 'Idioma actual',
        'Change Language': 'Cambiar idioma',
        'Select language': 'Seleccione un Idioma',
        'Exit': 'Salir',
        'Toggle Theme': 'Cambiar tema',
        'As Platform': 'Como plataforma',
        'Select Theme': 'Seleccionar tema',
        'Light': 'Claro',
        'Dark': 'Oscuro',
        'Open navigation menu': 'Abrir menu de navegación',
        'Close': 'Cerrar',
        'Delete': 'Borrar',
        'Remove': 'Retirar',
        'More': 'Más',
        'Next month': 'Mes siguiente',
        'Previous month': 'Mes anterior',
        'Next page': 'Página siguiente',
        'Previous page': 'Página anterior',
        'First page': 'Primera página',
        'Last page': 'Última página',
        'Show menu': 'Mostrar menú',
        'Navigation menu': 'Menú de navegación',
        'Popup menu': 'Menú emergente',
        'Dialog': 'Diálogo',
        'Alert': 'Alerta',
        'Search': 'Buscar',
        'Licenses': 'Licencias',
        'CANCEL': 'CANCELAR',
        'CLOSE': 'CERRAR',
        'CONTINUE': 'CONTINUAR',
        'Copy': 'Copiar',
        'Cut': 'Cortar',
        'OK': 'OK',
        'Paste': 'Pegar',
        'Select all': 'Seleccionar todo',
        'VIEW LICENSES': 'VER LICENCIAS',
        'AM': 'AM',
        'PM': 'PM',
        'Select hours': 'Seleccionar horas',
        'Select minutes': 'Seleccionar minutos',
        'Dismiss': 'Descartar',
        'Signed in': 'Conectado',
        'Hide accounts': 'Ocultar cuentas',
        'Show accounts': 'Mostrar cuentas',
        'Move up': 'Arriba',
        'Move down': 'Abajo',
        'Move left': 'Izquierda',
        'Move right': 'Derecha',
        'Move to the end': 'Fin',
        'Move to the start': 'Comienzo',
        'Collapse': 'Colapsar',
        'Expand': 'Expandir',
        'Refresh': 'Actualizar',
        'Select year': 'Seleccionar año',
        'Date': 'Fecha',
        'Date Range': 'Rango de Fechas',
        'Enter Date': 'Ingrese fecha',
        'Start Date': 'Fecha de inicio',
        'End Date': 'Fecha de fin',
        'Invalid date format.': 'Formato de fecha inválido.',
        'Invalid date range.': 'Rango de fechas inválido.',
        'Out of range.': 'Fuera de rango.',
        'SAVE': 'GRABAR',
        'SELECT DATE': 'SELECCIONAR FECHA',
        'SELECT RANGE': 'SELECCIONAR RANGO',
        'Switch to calendar': 'Cambiar al calendario',
        'Switch to input': 'Cambiar a entrada',
        'SELECT TIME': 'SELECCIONAR HORA',
        'ENTER TIME': 'INGRESAR HORA',
        'Hour': 'Hora',
        'Minute': 'Minuto',
        'Enter a valid time': 'Ingrese una hora válida',
        'Switch to dial picker mode': 'Cambiar a modo de selección',
        'Switch to text input mode': 'Cambiar a modo de entrada de texto',
        //Full name monthes
        'January': 'Enero',
        'February': 'Febrero',
        'March': 'Marzo',
        'April': 'Abril',
        'May': 'Mayo',
        'June': 'Junio',
        'July': 'Julio',
        'August': 'Agosto',
        'September': 'Septiembre',
        'October': 'Octubre',
        'November': 'Noviembre',
        'December': 'Diciembre',
        //Abbreviated months (3 letters)
        'Jan_abb': 'En',
        'Feb_abb': 'Febr',
        'Mar_abb': 'Mzo',
        'Apr_abb': 'Abr',
        'May_abb': 'My',
        'Jun_abb': 'Jun',
        'Jul_abb': 'Jul',
        'Aug_abb': 'Ag ',
        'Sep_abb': 'Sept',
        'Oct_abb': 'Oct',
        'Nov_abb': 'Nov',
        'Dec_abb': 'Dic',
        //Full name days
        'Monday': 'Lunes',
        'Tuesday': 'Martes',
        'Wednesday': 'Miércoles',
        'Thursday': 'Jueves',
        'Friday': 'Viernes',
        'Saturday': 'Sábado',
        'Sunday': 'Domingo',
        //Abbreviated days (1-2 letters)
        'Mon_day_abb_1': 'Lu',
        'Tue_day_abb_1': 'Ma',
        'Wed_day_abb_1': 'Mi',
        'Thu_day_abb_1': 'Ju',
        'Fri_day_abb_1': 'Vi',
        'Sat_day_abb_1': 'Sá',
        'Sun_day_abb_1': 'Do',
        //Abbreviated days (3 letters)
        'Mon': 'Lun',
        'Tue': 'Mar',
        'Wed': 'Mié',
        'Thu': 'Jue',
        'Fri': 'Vie',
        'Sat': 'Sáb',
        'Sun': 'Dom',
        //....
        'No characters remaining': 'No quedan caracteres',
        '1 character remaining': 'Falta 1 caracter',
        'characters remaining': 'Caracteres restantes',
        //...
        'No items selected': 'No ítems seleeccionados',
        '1 item selected': '1 ítem seleccionado',
        'items selected': 'Ítems seleccionados',
        //...
        'No licenses.': 'Sin licencia',
        '1 license.': '1 licencia.',
        'licenses.': 'licensias.'
      };
}
